Imports System.IO
Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        gvCustomers.DataSource = Me.GetData("SELECT CustomerID, City FROM Customers")
        gvCustomers.DataBind()
        gvOrders.DataSource = Me.GetData("SELECT OrderID, CustomerID FROM Orders")
        gvOrders.DataBind()
    End Sub

    Private Function GetData(ByVal query As String) As DataTable
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(query, con)
                Using dt As DataTable = New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub OnPaging(ByVal sender As Object, ByVal e As GridViewPageEventArgs)
        Dim gridView As GridView = CType(sender, GridView)
        gridView.PageIndex = e.NewPageIndex
        gridView.DataBind()
    End Sub

    Protected Sub ExportToExcel(ByVal sender As Object, ByVal e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.xls")
        Response.Charset = ""
        Response.ContentType = "application/vnd.ms-excel"

        Using sw As StringWriter = New StringWriter()
            Dim hw As HtmlTextWriter = New HtmlTextWriter(sw)

            Me.PrepareForExport(gvCustomers)
            Me.PrepareForExport(gvOrders)

            Dim table As Table = New Table()

            Dim row1 As TableRow = New TableRow()

            Dim cell1 As TableCell = New TableCell()
            cell1.Controls.Add(gvCustomers)
            row1.Cells.Add(cell1)

            Dim cell2 As TableCell = New TableCell()
            cell2.Text = "&nbsp;"

            Dim cell3 As TableCell = New TableCell()
            cell3.Controls.Add(gvOrders)

            If rbPreference.SelectedValue = "2" Then
                row1.Cells.Add(cell2)
                row1.Cells.Add(cell3)
                table.Rows.Add(row1)
            Else
                Dim tr2 As TableRow = New TableRow()
                tr2.Cells.Add(cell2)
                Dim tr3 As TableRow = New TableRow()
                tr3.Cells.Add(cell3)
                table.Rows.Add(row1)
                table.Rows.Add(tr2)
                table.Rows.Add(tr3)
            End If
            table.RenderControl(hw)

            'style to format numbers to string.
            Dim style As String = "<style> .textmode { mso-number-format:\@; } </style>"
            Response.Write(style)
            Response.Output.Write(sw.ToString())
            Response.Flush()
            Response.End()
        End Using
    End Sub

    Protected Sub PrepareForExport(ByVal gridView As GridView)
        gridView.AllowPaging = Convert.ToBoolean(rbPaging.SelectedItem.Value)
        gridView.PagerSettings.Visible = False
        gridView.DataBind()

        For Each row As GridViewRow In gridView.Rows
            'Apply text style to each Row.
            row.Attributes.Add("class", "textmode")
        Next
    End Sub
End Class

Public Overrides Sub VerifyRenderingInServerForm(ByVal control As Control)
End Sub